﻿using CommunityToolkit.Mvvm.ComponentModel;

namespace SocialEducatorAvalonia.DTOs
{
    public  partial class PersonsPayment : ObservableObject
    {
        [ObservableProperty]
        double _id;

        [ObservableProperty]
        int _studentId;

        [ObservableProperty]
        string _fIO = string.Empty;

        [ObservableProperty]
        string _name  = string.Empty;

        [ObservableProperty]
        string _surname  = string.Empty;

        [ObservableProperty]
        string _patronymic = string.Empty;

        [ObservableProperty]
        string _group = string.Empty;

        [ObservableProperty]
        decimal _payment = 0;

        [ObservableProperty]
        string _paymentType  = string.Empty;
        
        [ObservableProperty] 
        int _dataAdmission = 2015;

        [ObservableProperty]
        DateTime _currentPaymentDate = DateTime.Now;

        [ObservableProperty]
        DateTime? _endRangeDate = null;

        [ObservableProperty]
        bool _isChecked = false;

        [ObservableProperty]
        bool _existInDB = false;

        public bool Equals(PersonsPayment other)
        {
            if (other == null) return false;
            return FIO == other.FIO && Group == other.Group && DataAdmission == other.DataAdmission && Name == other.Name &&
                Surname == other.Surname && Patronymic == other.Patronymic;
        }

    }
}
