﻿using CommunityToolkit.Mvvm.ComponentModel;
using SocialEducatorAvalonia.Models;
using SocialEducatorAvalonia.Utilities;
using System.Collections.Immutable;
using System.Linq;

namespace SocialEducatorAvalonia.ViewModels
{
    /// <summary>
    /// Класс который наследуется каждой ViewModel
    /// </summary>
    public partial class ViewModelBase : ObservableObject
    {
        // dotnet ef dbcontext scaffold "Host=ngknn.ru;Port=5442;Username=41P;Password=12357;Database=socialeducation" Npgsql.EntityFrameworkCore.PostgreSQL -o Models -f

        public static MainWindowViewModel MainVM { get; set; }

        #region navigation
        private static PageSwitcher _pageSwitcher = new();
        public static PageSwitcher PageSwitcher { get => _pageSwitcher; set => _pageSwitcher = value;}

        //[ObservableProperty]
        //static PageSwitcher _pageSwitcher = new();
        #endregion

        /// <summary>
        /// Объект контекста БД
        /// </summary>
        public static SocialeducationContext DbContext = new SocialeducationContext();

        //эти данные будут весьма часто фигурировать, и чтобы лишний раз не применять join и обращаться к БД, напишем здесь эти константные данные
        /// <summary>
        /// Ключ - Группа как текст. Значение - Id 
        /// </summary>
        public readonly static ImmutableSortedDictionary<string, int> GroupDict = DbContext.Groups.OrderBy(x => x.Title).ToImmutableSortedDictionary(x => x.Title.ToString(), x => (int)x.GroupId);

        /// <summary>
        /// Неизменяемый отсортированный словарь статусов {Статус - Id}
        /// </summary>
        public readonly static ImmutableSortedDictionary<string, int> StatusDict = DbContext.StudentsStatuses.OrderBy(x => x.Title).ToImmutableSortedDictionary(x => x.Title, x => x.StatusId);
    }
}
