# **Приложение для социального педагога**

Это приложение упрощает мониторинг выплат. Оно интегрируется с "NPOI", "ExcelDataReader", и "AvaloniaMbox", и создано на платформе **"AvaloniaUI" Version="11.0.11"** с использованием "MVVM Community Toolkit".

## Некоторые требования и напутствия

Проект расчитан на целевую платформу .NET 8 [поэтому установите её по ссылке](https://dotnet.microsoft.com/en-us/download/dotnet/8.0). Убедитесь, что Вы установили как платформу так и SDK компоненты.

Для установки на рабочее место сотрудника выполните следующую CLI-команду для установки шаблонов AvaloniaUI, а затем используйте команды для компиляции и запуска проекта:

```bash
dotnet new install Avalonia.Templates (установка шаблонов AvaloniaUI)

dotnet build (необходимо быть в папке проекта, команда для сборки решения)

dotnet run (запуск программы)
```

Рекомендуется выгрузить проект с помощью Git и затем скомпилировать его на устройстве.

А для разработки на VisualStudio [установите это расширение](https://marketplace.visualstudio.com/items?itemName=AvaloniaTeam.AvaloniaVS)

На всякий случай в решении есть папка **"DumpsDB"** с единственным файлом, в нем sql-скрипт, с помощью которого можно восстановить базу данных.

## Советы в сопровождении

* **Навигация**: Рекомендуется переработать навигацию в приложении. В настоящее время она привязана к объекту, в который вложены страницы приложения, и обращение к этому объекту происходит напрямую, что требует изменения на существующий экземпляр других объектов.
* **Переход на тестовую базу данных**: Для перехода на тестовую базу данных используйте connectionString из launchSettings и замените значение DefaultCon в AddStudentViewModel и SocialContext.
* **Валидация**: Необходимо улучшить валидацию в AddPaymentVM. Текущая реализация требует более тщательной проверки данных.
* **Поддержка форматов файлов**: В настоящее время поддерживаются файлы формата ".xlsx". С помощью библиотек NPOI и ExcelDataReader можно добавить поддержку форматов ".xlsb" и ".csv". Однако для этого потребуется доработка функционала в тех частях кода, где есть связь с библиотекой NPOI.
* **Коментарии**: в целом с помощью сочетаний клавиш "Ctrl Shift / + t" по ключевому слову "TODO:" я помечал некоторые нюансы, которые требуют доработки





Контактная информация (tg: @nanech22) - Никита